## ddisasm-99a152e3443cf99844343f81d96045725bb67a21.tar.gz

=== CMakeLists.txt ===
#
# Cmake Configuration
#

# We use 3.12.1 to ease compatability with gtirb-pprinter.
cmake_minimum_required(VERSION 3.12.1)

# Get version
file(READ "${CMAKE_CURRENT_SOURCE_DIR}/version.txt" ver)

string(REGEX MATCH "VERSION_MAJOR ([0-9]*)" _ ${ver})
set(DDISASM_MAJOR_VERSION ${CMAKE_MATCH_1})

string(REGEX MATCH "VERSION_MINOR ([0-9]*)" _ ${ver})
set(DDISASM_MINOR_VERSION ${CMAKE_MATCH_1})

string(REGEX MATCH "VERSION_PATCH ([0-9]*)" _ ${ver})
set(DDISASM_PATCH_VERSION ${CMAKE_MATCH_1})

project(
  DDISASM
  VERSION
    "${DDISASM_MAJOR_VERSION}.${DDISASM_MINOR_VERSION}.${DDISASM_PATCH_VERSION}"
)

#
# Global Options (CMake)
#

option(DDISASM_ARM_32 "Whether or not ARM support is built." ON)
option(DDISASM_ARM_64 "Whether or not ARM64 support is built." ON)
option(DDISASM_MIPS_32 "Whether or not MIPS support is built." ON)
option(DDISASM_X86_32 "Whether or not x86_32 support is built." ON)
option(DDISASM_X86_64 "Whether or not x86_64 support is built." ON)
option(DDISASM_SOUFFLE_PROFILING "Whether to generate Souffle profiles." OFF)

option(DDISASM_GENERATE_MANY "Whether to have Souffle generate multiple files."
       OFF)
option(DDISASM_RELEASE_VERSION
       "Whether or not to build Python package versions without dev suffixes."
       OFF)

if(NOT DEFINED DDISASM_BUILD_REVISION)
  execute_process(
    COMMAND git log --pretty=format:%h -n 1
    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
    OUTPUT_VARIABLE DDISASM_BUILD_REVISION
    ERROR_QUIET)
endif()
if(DDISASM_BUILD_REVISION STREQUAL "")
  set(DDISASM_BUILD_REVISION "UNKNOWN")
endif()

string(TIMESTAMP DDISASM_BUILD_DATE "%Y-%m-%d")

if(DDISASM_ARM_64)
  list(APPEND DDISASM_ARCH_LIST "ARM64")
endif()
if(DDISASM_X86_32)
  list(APPEND DDISASM_ARCH_LIST "IA32")
endif()
if(DDISASM_X86_64)
  list(APPEND DDISASM_ARCH_LIST "X64")
endif()
if(DDISASM_ARM_32)
  list(APPEND DDISASM_ARCH_LIST "ARM32")
endif()
if(DDISASM_MIPS_32)
  list(APPEND DDISASM_ARCH_LIST "MIPS32")
endif()
list(JOIN DDISASM_ARCH_LIST "+" DDISASM_BUILD_ARCH_TARGETS)

option(DDISASM_ENABLE_TESTS "Enable building and running unit tests." ON)

option(ENABLE_CONAN "Use Conan to inject dependencies" OFF)

if(ENABLE_CONAN)
  include(${CMAKE_BINARY_DIR}/conanbuildinfo.cmake)
  conan_basic_setup(TARGETS)
endif()

# The libraries can be static while the drivers can link in other things in a
# shared manner. This option allows for this possibility.
option(
  DDISASM_STATIC_DRIVERS
  "Attempt to make any driver executables as statically-linked as possible.
Implies DDISASM_BUILD_SHARED_LIBS=OFF."
  OFF)

if(DDISASM_STATIC_DRIVERS)
  set(Boost_USE_STATIC_LIBS ON)

  if(WIN32)
    set(CMAKE_FIND_LIBRARY_SUFFIXES ".lib")
  else()
    set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
  endif()
endif()

# This just sets the builtin BUILD_SHARED_LIBS, but if defaults to ON instead of
# OFF.
option(DDISASM_BUILD_SHARED_LIBS "Build shared libraries." ON)
option(DDISASM_USE_SYSTEM_BOOST "Use system-wide installation of Boost." OFF)
if(DDISASM_STATIC_DRIVERS OR NOT DDISASM_BUILD_SHARED_LIBS)
  set(BUILD_SHARED_LIBS OFF)
else()
  set(BUILD_SHARED_LIBS ON)
endif()

# Determine whether or not to strip debug symbols and set the build-id. This is
# only really needed when we are building ubuntu *-dbg packages
option(DDISASM_STRIP_DEBUG_SYMBOLS
       "Whether or not to strip debug symbols and set the build-id." OFF)

set_property(GLOBAL PROPERTY USE_FOLDERS ON)
if(WIN32)
  set(CMAKE_DEBUG_POSTFIX
      "d"
      CACHE STRING "add a postfix, usually d on windows")
endif()
set(CMAKE_RELEASE_POSTFIX
    ""
    CACHE STRING "add a postfix, usually empty on windows")
set(CMAKE_RELWITHDEBINFO_POSTFIX
    ""
    CACHE STRING "add a postfix, usually empty on windows")
set(CMAKE_MINSIZEREL_POSTFIX
    ""
    CACHE STRING "add a postfix, usually empty on windows")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_CXX_EXTENSIONS OFF)

# Use C++17
set(CMAKE_CXX_STANDARD 17)
# Error if it's not available
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Specifically check for gcc-7 or later. gcc-5 is installed on many systems and
# will accept -std=c++17, but does not fully support the standard.
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "7.0.0")
    message(FATAL_ERROR "gcc 7 or later is required to build gtirb")
  endif()
endif()

set(CMAKE_CXX_VISIBILITY_PRESET hidden)

# If we're using libc++, we need to manually include libc++abi (unlike with
# using libstdc++, which automatically does this)
include(CheckCXXSourceCompiles)

check_cxx_source_compiles(
  "
  #include <ciso646>
  int main() {
    return _LIBCPP_VERSION;
  }
"
  USING_LIBCPP)

if(USING_LIBCPP)
  if(BUILD_SHARED_LIBS)
    find_library(LIBCPP_ABI NAMES c++abi)
  else()
    find_library(LIBCPP_ABI NAMES libc++abi.a)
  endif()

  if(NOT LIBCPP_ABI)
    message(FATAL_ERROR "libc++abi not found")
  endif()
endif()

# Using libstdc++'s std::filesystem in GCC 8 needs to have libstdc++fs linked
# in. Because one could use libstdc++ with Clang instead of gcc, we detect
# whether to use the flag by just trying it out.
check_cxx_source_compiles(
  "
  #include <ciso646>
  int main() {
    return _GLIBCXX_RELEASE;
  }
  "
  USING_LIBSTDCXX)

if(USING_LIBSTDCXX)
  include(CMakePushCheckState)
  cmake_push_check_state(RESET)

  set(CMAKE_REQUIRED_FLAGS -std=c++17)
  check_cxx_source_compiles(
    "
    #include <filesystem>
    int main() {
        return std::filesystem::path(\"/\").is_absolute() ? 0 : 1;
    }
    "
    LIBSTDCXX_WORKS_WITHOUT_LIBFS)

  if(NOT LIBSTDCXX_WORKS_WITHOUT_LIBFS)
    set(CMAKE_REQUIRED_LIBRARIES stdc++fs)
    check_cxx_source_compiles(
      "
      #include <filesystem>
      int main() {
        return std::filesystem::path(\"/\").is_absolute() ? 0 : 1;
      }
      "
      LIBSTDCXX_WORKS_WITH_LIBFS)

    if(LIBSTDCXX_WORKS_WITH_LIBFS)
      set(LIBSTDCXX_FS stdc++fs)
    else()
      message(FATAL_ERROR "could not determine how to link std::filesystem")
    endif()
  endif()

  cmake_pop_check_state()
endif()

# ---------------------------------------------------------------------------
# gtirb
# ---------------------------------------------------------------------------
find_package(gtirb 2.2.0 REQUIRED)

add_definitions(-DGTIRB_WRAP_UTILS_IN_NAMESPACE)

# ---------------------------------------------------------------------------
# pretty-printer
# ---------------------------------------------------------------------------
find_package(gtirb_pprinter 2.0.0 REQUIRED)

# ---------------------------------------------------------------------------
# libehp
# ---------------------------------------------------------------------------

# ehp builds the necessary cmake files, but does not install them. If
# find_package fails, fall back to looking for the library and header file
# directly.

if(NOT ehp_LIBRARIES OR NOT ehp_INCLUDE_DIR)
  find_package(ehp QUIET)
  if(ehp_FOUND)
    # When find_package finds ehp, it runs add_library(ehp) which this project
    # must link against by name.
    set(ehp_LIBRARIES ehp)
  else()
    find_library(
      ehp_LIBRARIES
      NAMES ehp
      HINTS ${ehp_ROOT}/lib $ENV{ehp_ROOT}/lib)
    if(ehp_LIBRARIES)
      message(STATUS "Found ehp: ${ehp_LIBRARIES}")
    else()
      message(
        SEND_ERROR
          "could not find ehp library file\n"
          "Try setting \"ehp_ROOT\" to the ehp installation directory, or set "
          "\"ehp_DIR\" to the ehp build directory.")
    endif()

    find_path(
      ehp_INCLUDE_DIR
      NAMES ehp.hpp
      HINTS ${ehp_ROOT}/include $ENV{ehp_ROOT}/include)
    if(ehp_INCLUDE_DIR)
      message(STATUS "Found ehp: ${ehp_INCLUDE_DIR}")
    else()
      message(
        SEND_ERROR
          "could not find ehp header file: ehp.hpp\n"
          "Try setting \"ehp_ROOT\" to the ehp installation directory, or set "
          "\"ehp_DIR\" to the ehp build directory.")
    endif()
  endif()
endif()

# ---------------------------------------------------------------------------
# Boost
# ---------------------------------------------------------------------------
#
# Note: we would like to use std::filsystem. However, currently, std::filesystem
# is not provided in clang 6 or gcc 7, both of which are the default installed
# versions for Ubuntu 18. Instead in that context, one can use the
# "experimental" version fo filesystem. But we've decided that it's simpler to
# just use boost::filesystem instead until we (eventually) drop support for
# Ubuntu 18.
set(BOOST_COMPONENTS filesystem program_options system)
find_package(Boost 1.67 REQUIRED COMPONENTS ${BOOST_COMPONENTS})

# Boost versions 1.70.0+ may use Boost's provided CMake support rather than
# CMake's internal Boost support. The former uses "Boost::boost" and so on,
# while the latter uses "Boost_BOOST" and so on. This normalizes the two cases
# to use Boost_INCLUDE_DIRS and Boost_LIBRARIES.
if(TARGET Boost::headers)
  get_target_property(Boost_INCLUDE_DIRS Boost::headers
                      INTERFACE_INCLUDE_DIRECTORIES)
  foreach(BOOST_COMPONENT ${BOOST_COMPONENTS})
    list(APPEND Boost_LIBRARIES Boost::${BOOST_COMPONENT})
  endforeach()
endif()

include_directories(${Boost_INCLUDE_DIRS})

# ---------------------------------------------------------------------------
# capstone
# ---------------------------------------------------------------------------
if(BUILD_SHARED_LIBS)
  find_library(CAPSTONE NAMES capstone)
else()
  find_library(CAPSTONE NAMES libcapstone.a)
endif()

if(CAPSTONE)
  find_program(CSTOOL "cstool")
  # When using conan to install the dependencies but CMake to do the build, the
  # capstone libraries may not be findable by the loader. Set LD_LIBRARY path to
  # fix this.
  get_filename_component(CAPSTONE_LIB_DIR "${CAPSTONE}" DIRECTORY)
  execute_process(
    COMMAND ${CMAKE_COMMAND} -E env
            "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:${CAPSTONE_LIB_DIR}" #
            "${CSTOOL}" "-v" OUTPUT_VARIABLE CSTOOL_VERSION)
  string(REGEX MATCH "v([0-9]+\.[0-9]+\.[0-9]+)" CSTOOL_VERSION
               "${CSTOOL_VERSION}")
  set(CSTOOL_VERSION "${CMAKE_MATCH_1}")
endif()

if(NOT CAPSTONE OR "${CSTOOL_VERSION}" VERSION_LESS "5.0.1")
  message(
    FATAL_ERROR
      " No Capstone installation found.\n"
      " - If Capstone is not installed, install it from souce.\n"
      "   You can get the latest version of Capstone at:\n"
      "       http://www.capstone-engine.org/\n"
      " - If Capstone is installed, make sure the installation location is in your PATH,\n"
      "   and it is at least version 5.0.1.\n")
endif()

if(NOT CAPSTONE_INCLUDE_DIR)
  get_filename_component(CAPSTONE_LIB_DIR ${CAPSTONE} DIRECTORY)
  get_filename_component(CAPSTONE_INCLUDE_DIR ${CAPSTONE_LIB_DIR}/../include
                         ABSOLUTE)
  if(NOT EXISTS ${CAPSTONE_INCLUDE_DIR}/capstone)
    message(WARNING "CAPSTONE_INCLUDE_DIR not found")
    unset(CAPSTONE_INCLUDE_DIR)
  endif()
  unset(CAPSTONE_LIB_DIR)
endif()

# ---------------------------------------------------------------------------
# LIEF
# ---------------------------------------------------------------------------
if(ENABLE_CONAN)
  set(LIEF_LIBRARIES CONAN_PKG::lief)
else()
  find_package(LIEF 0.16.6 REQUIRED COMPONENTS STATIC)
endif()

# ---------------------------------------------------------------------------
# Google Test Application
# ---------------------------------------------------------------------------
if(DDISASM_ENABLE_TESTS)
  enable_testing()
  # Pull in Google Test
  # https://github.com/google/googletest/tree/master/googletest#incorporating-
  # into-an-existing-cmake-project

  # Download and unpack googletest at configure time
  configure_file(CMakeLists.googletest googletest-download/CMakeLists.txt)

  execute_process(
    COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    RESULT_VARIABLE result

=== doc/CMakeLists.txt ===
find_program(
  PANDOC pandoc
  HINTS $ENV{PATH}
  DOC "pandoc must be in your PATH to build documentation.")
find_program(
  GZIP gzip
  HINTS $ENV{PATH}
  DOC "gzip must be in your PATH to build documentation.")
if(NOT PANDOC)
  message(
    WARNING "pandoc was not found in your PATH. Unable to build documentation.")
elseif(NOT GZIP)
  message(
    WARNING "gzip was not found in your PATH. Unable to build documentation.")
else()
  set(MANUAL_MD "${CMAKE_CURRENT_SOURCE_DIR}/ddisasm.md")
  set(MANUAL_HTML "${CMAKE_BINARY_DIR}/doc/ddisasm.html")
  set(MANUAL_MAN "${CMAKE_BINARY_DIR}/doc/ddisasm.md.tmp")
  set(MANUAL_MAN_GZ "${CMAKE_BINARY_DIR}/doc/ddisasm.1.gz")

  add_custom_command(
    OUTPUT ${MANUAL_HTML}
    COMMAND
      ${PANDOC} -s -t html ${MANUAL_MD} -o ${MANUAL_HTML}
    DEPENDS ${MANUAL_MD})
  add_custom_command(
    OUTPUT ${MANUAL_MAN}
    COMMAND
      ${PANDOC} -s -t man ${MANUAL_MD} -o ${MANUAL_MAN}
    DEPENDS ${MANUAL_MD})
  add_custom_command(
    OUTPUT ${MANUAL_MAN_GZ}
    COMMAND ${GZIP} -9 < ${MANUAL_MAN} -> ${MANUAL_MAN_GZ}
    DEPENDS ${MANUAL_MAN})

  add_custom_target(
    doc
    DEPENDS ${MANUAL_HTML}
    DEPENDS ${MANUAL_MAN_GZ})
endif()

=== doc/Makefile ===
SPHINXOPTS    ?=
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = source
BUILDDIR      = build

default:
	python3  build_index.py
	@$(SPHINXBUILD) "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)


help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

%:
	python3  build_index.py
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

clean:
	rm -rf build

=== examples/Makefile ===
TOPTARGETS := all clean

SUBDIRS := $(wildcard */.)

$(TOPTARGETS): $(SUBDIRS)
$(SUBDIRS):
	$(MAKE) -C $@ $(MAKECMDGOALS)

.PHONY: $(TOPTARGETS) $(SUBDIRS)

=== python/CMakeLists.txt ===
function(make_absolute variable path)
  file(READ_SYMLINK "${path}" link_path)
  if(NOT IS_ABSOLUTE "${link_path}")
    get_filename_component(dir "${path}" DIRECTORY)
    set(path "${dir}/${link_path}")
  endif()
  set(${variable}
      "${path}"
      PARENT_SCOPE)
endfunction()

if(DDISASM_RELEASE_VERSION)
  set(DDISASM_PYTHON_DEV_SUFFIX "")
else()
  set(DDISASM_PYTHON_DEV_SUFFIX ".dev")
endif()

# TODO: GTIRB_RELEASE_VERSION or GTIRB_PYTHON_DEV_SUFFIX should come from the
# GTIRB conan files and not get guessed at here.
if(DDISASM_RELEASE_VERSION)
  set(GTIRB_PYTHON_DEV_SUFFIX "")
else()
  set(GTIRB_PYTHON_DEV_SUFFIX ".dev")
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in
               ${CMAKE_CURRENT_BINARY_DIR}/setup.py @ONLY)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/version.py.in
               ${CMAKE_CURRENT_BINARY_DIR}/version.py @ONLY)

find_library(GTIRB_LIBRARY_PATH gtirb)
make_absolute(GTIRB_LIBRARY_PATH ${GTIRB_LIBRARY_PATH})

find_library(PPRINTER_LIBRARY_PATH gtirb_pprinter)
make_absolute(PPRINTER_LIBRARY_PATH ${PPRINTER_LIBRARY_PATH})

find_library(LAYOUT_LIBRARY_PATH gtirb_layout)
make_absolute(LAYOUT_LIBRARY_PATH ${LAYOUT_LIBRARY_PATH})

find_library(CAPSTONE_LIBRARY_PATH capstone)
make_absolute(CAPSTONE_LIBRARY_PATH ${CAPSTONE_LIBRARY_PATH})

file(GLOB PY_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/ddisasm/*.py)

add_custom_target(pyddisasm ALL DEPENDS ${PY_SOURCES} ddisasm)
add_custom_command(
  TARGET pyddisasm
  COMMAND ${CMAKE_COMMAND} -E copy_directory "${CMAKE_CURRENT_SOURCE_DIR}/src"
          "${CMAKE_CURRENT_BINARY_DIR}/src"
  COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_SOURCE_DIR}/README.md"
          "${CMAKE_CURRENT_BINARY_DIR}/"
  COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_BINARY_DIR}/version.py"
          "${CMAKE_CURRENT_BINARY_DIR}/src/ddisasm/"
  COMMAND ${CMAKE_COMMAND} -E make_directory
          "${CMAKE_CURRENT_BINARY_DIR}/src/ddisasm/.libs/"
  COMMAND ${CMAKE_COMMAND} -E copy ${GTIRB_LIBRARY_PATH}
          "${CMAKE_CURRENT_BINARY_DIR}/src/ddisasm/.libs/"
  COMMAND ${CMAKE_COMMAND} -E copy ${GTIRB_LIBRARY_PATH}
          "${CMAKE_CURRENT_BINARY_DIR}/src/ddisasm/.libs/"
  COMMAND ${CMAKE_COMMAND} -E copy ${PPRINTER_LIBRARY_PATH}
          "${CMAKE_CURRENT_BINARY_DIR}/src/ddisasm/.libs/"
  COMMAND ${CMAKE_COMMAND} -E copy ${LAYOUT_LIBRARY_PATH}
          "${CMAKE_CURRENT_BINARY_DIR}/src/ddisasm/.libs/"
  COMMAND ${CMAKE_COMMAND} -E copy ${CAPSTONE_LIBRARY_PATH}
          "${CMAKE_CURRENT_BINARY_DIR}/src/ddisasm/.libs/"
  COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:ddisasm>
          "${CMAKE_CURRENT_BINARY_DIR}/src/ddisasm/")
if(UNIX AND NOT APPLE)
  add_custom_command(
    TARGET pyddisasm
    COMMAND patchelf --set-rpath '$$ORIGIN/.libs'
            "${CMAKE_CURRENT_BINARY_DIR}/src/ddisasm/ddisasm"
    COMMAND patchelf --set-rpath '$$ORIGIN'
            "${CMAKE_CURRENT_BINARY_DIR}/src/ddisasm/.libs/*")
endif()

# Convenience targets for installing python
find_program(PYTHON3 "python3")
add_custom_target(
  python-wheel
  DEPENDS pyddisasm
  COMMAND "${PYTHON3}" setup.py bdist_wheel)

=== src/CMakeLists.txt ===
# Common settings for MSVC
function(set_common_msvc_options TARGET_NAME)

  target_compile_options(${TARGET_NAME} PRIVATE "-W4") # Sets warning level.

  # FIXME: Visual studio does not deactivate warnings so for now warnings do not
  # result in errors. target_compile_options(${TARGET_NAME} PRIVATE "-WX")

  # target_compile_options( ${TARGET_NAME} PRIVATE "-wd4127") # conditional
  # expression is constant

  # target_compile_options( ${TARGET_NAME} PRIVATE "-wd4244") # 'conversion'
  # conversion from 'type1' to 'type2', possible loss of data

  target_compile_options(${TARGET_NAME} PRIVATE "-permissive-")
  target_compile_options(${TARGET_NAME} PRIVATE "-EHsc")
  target_compile_options(${TARGET_NAME} PRIVATE "-bigobj")

  target_compile_options(${TARGET_NAME} PRIVATE $<$<CONFIG:Debug>:-D_DEBUG>)
  target_compile_options(${TARGET_NAME} PRIVATE $<$<CONFIG:Debug>:-MDd>)
  target_compile_options(${TARGET_NAME} PRIVATE $<$<CONFIG:Debug>:-Ob0>
  )# Disables inline expansion
  target_compile_options(
    ${TARGET_NAME} PRIVATE $<$<CONFIG:Debug>:-Od>) # Disables optimization,
                                                   # speeding compilation and
                                                   # simplifying debugging. http
                                                   # s://msdn.microsoft.com/en-
                                                   # us/library/k1ack8f1.aspx
  target_compile_options(${TARGET_NAME} PRIVATE $<$<CONFIG:Debug>:-RTC1>
  )# Enables run-time error checking.
  target_compile_options(${TARGET_NAME} PRIVATE $<$<CONFIG:Debug>:-Zi>
  )# Generates complete debugging information.

  target_compile_options(${TARGET_NAME}
                         PRIVATE $<$<CONFIG:RelWithDebInfo>:-D_NDEBUG>)
  target_compile_options(${TARGET_NAME}
                         PRIVATE $<$<CONFIG:RelWithDebInfo>:-DNDEBUG>)
  target_compile_options(${TARGET_NAME} PRIVATE $<$<CONFIG:RelWithDebInfo>:-MD>)
  target_compile_options(${TARGET_NAME} PRIVATE $<$<CONFIG:RelWithDebInfo>:-O2>
  )# Creates fast code.
  target_compile_options(
    ${TARGET_NAME} PRIVATE $<$<CONFIG:RelWithDebInfo>:-Ob2>) # The default
                                                             # value. Allows
                                                             # expansion of
                                                             # functions marked
                                                             # as inline,
                                                             # __inline, or
                                                             # __forceinline,
                                                             # and any other
                                                             # function that the
                                                             # compiler chooses.
  target_compile_options(${TARGET_NAME} PRIVATE $<$<CONFIG:RelWithDebInfo>:-Oi>
  )# Generates intrinsic functions.
  target_compile_options(${TARGET_NAME} PRIVATE $<$<CONFIG:RelWithDebInfo>:-Ot>
  )# Favors fast code.
  target_compile_options(${TARGET_NAME} PRIVATE $<$<CONFIG:RelWithDebInfo>:-Zi>
  )# Generates complete debugging information.

  target_compile_options(${TARGET_NAME} PRIVATE $<$<CONFIG:Release>:-D_NDEBUG>)
  target_compile_options(${TARGET_NAME} PRIVATE $<$<CONFIG:Release>:-DNDEBUG>)
  target_compile_options(${TARGET_NAME} PRIVATE $<$<CONFIG:Release>:-MD>)
  target_compile_options(${TARGET_NAME} PRIVATE $<$<CONFIG:Release>:-O2>
  )# Creates fast code.
  target_compile_options(
    ${TARGET_NAME} PRIVATE $<$<CONFIG:Release>:-Ob2>) # The default value.
                                                      # Allows expansion of
                                                      # functions marked as
                                                      # inline, __inline, or
                                                      # __forceinline, and any
                                                      # other function that the
                                                      # compiler chooses.
  target_compile_options(${TARGET_NAME} PRIVATE $<$<CONFIG:Release>:-Oi>
  )# Generates intrinsic functions.
  target_compile_options(${TARGET_NAME} PRIVATE $<$<CONFIG:Release>:-Ot>
  )# Favors fast code.

endfunction()

# Disabled warnings for souffle projects on MSVC
function(set_souffle_msvc_options TARGET_NAME)
  target_compile_definitions(${TARGET_NAME} PRIVATE _CRT_SECURE_NO_WARNINGS)
  target_compile_definitions(${TARGET_NAME} PRIVATE _CRT_NONSTDC_NO_WARNINGS)

  # From cpp generated by souffle:
  target_compile_options(
    ${TARGET_NAME} PRIVATE -wd4146) # unary minus operator applied to unsigned
                                    # type, result still unsigned
  target_compile_options(
    ${TARGET_NAME} PRIVATE -wd4189) # 'identifier' : local variable is
                                    # initialized but not referenced

  # From souffle headers
  target_compile_options(
    ${TARGET_NAME} PRIVATE -wd4267) # conversion from 'type1' to 'type2',
                                    # possible loss of data

  target_compile_options(
    ${TARGET_NAME} PRIVATE -wd4456) # declaration of 'decl' hides previous local
                                    # declaration
endfunction()

# ===== generated souffle code =====
find_program(
  SOUFFLE souffle
  HINTS $ENV{PATH}
  DOC "souffle must be in your PATH to build disassembler.")
if(NOT SOUFFLE)
  message(FATAL_ERROR "souffle was not found in your PATH. Unable to build.")
endif()
if(NOT SOUFFLE_INCLUDE_DIR)
  get_filename_component(SOUFFLE_BIN_DIR ${SOUFFLE} DIRECTORY)
  get_filename_component(SOUFFLE_INCLUDE_DIR ${SOUFFLE_BIN_DIR}/../include
                         ABSOLUTE)
  if(NOT EXISTS ${SOUFFLE_INCLUDE_DIR}/souffle)
    message(WARNING "SOUFFLE_INCLUDE_DIR not found")
    unset(SOUFFLE_INCLUDE_DIR)
  endif()
  unset(SOUFFLE_BIN_DIR)
endif()

# Souffle searches for a "mcpp" binary, even on Windows, where "mcpp.exe" would
# probably make more sense. We explicitly provide the preprocessor.
if(WIN32)
  set(SOUFFLE_PREPROCESSOR_ARG "--preprocessor=mcpp.exe")
else()
  set(SOUFFLE_PREPROCESSOR_ARG "")
endif()

if(DDISASM_SOUFFLE_PROFILING)
  # We only need the presence of the argument.
  set(SOUFFLE_PROFILING_ARG "--profile=")
else()
  set(SOUFFLE_PROFILING_ARG "")
endif()

set(DATALOG_BASE_SOURCES
    datalog/arch/arch.dl
    datalog/binary/elf/elf_binaries.dl
    datalog/binary/elf/exceptions.dl
    datalog/binary/elf/symbolization.dl
    datalog/binary/elf/tls.dl
    datalog/binary/pe/pe_binaries.dl
    datalog/binary/pe/exceptions.dl
    datalog/binary/pe/relocations.dl
    datalog/basic_def_used.dl
    datalog/bitmasks.dl
    datalog/boundary_value_analysis.dl
    datalog/code_inference.dl
    datalog/code_inference_postprocess.dl
    datalog/code_inference_weights.dl
    datalog/cfg.dl
    datalog/data.dl
    datalog/data_access_analysis.dl
    datalog/empty_range.dl
    datalog/basic_function_inference.dl
    datalog/jump_tables.dl
    datalog/main.dl
    datalog/noreturn.dl
    datalog/pointer_reattribution.dl
    datalog/register_type_analysis.dl
    datalog/relative_jump_tables.dl
    datalog/symbols.dl
    datalog/symbolization.dl
    datalog/use_def_analysis.dl
    datalog/value_analysis.dl
    datalog/debug_stats.dl
    datalog/self_diagnose.dl
    datalog/straight_line_def_used.dl)

set(SOUFFLE_DATALOG_DIR ${CMAKE_CURRENT_SOURCE_DIR}/datalog/)

function(GENERATE_ARCH_CPP_SINGLE)
  cmake_parse_arguments(PARAM "" "ARCH;MARCH;PATH" "DATALOG_SOURCES" ${ARGV})

  string(TOLOWER ${PARAM_ARCH} ARCH)
  add_custom_command(
    OUTPUT "${PARAM_PATH}.cpp"
    WORKING_DIRECTORY "${SOUFFLE_DATALOG_DIR}"
    COMMAND
      ${SOUFFLE} main.dl -g "${CMAKE_BINARY_DIR}/src/${PARAM_PATH}.cpp" -jauto
      -MARCH_${PARAM_MARCH} ${SOUFFLE_PREPROCESSOR_ARG} ${SOUFFLE_PROFILING_ARG}
      -N ddisasm_${ARCH}
    DEPENDS ${DATALOG_BASE_SOURCES} ${PARAM_DATALOG_SOURCES})
endfunction()

function(GENERATE_ARCH_CPP_MANY)
  cmake_parse_arguments(PARAM "" "ARCH;MARCH;PATH" "DATALOG_SOURCES" ${ARGV})
  string(TOLOWER ${PARAM_ARCH} ARCH)
  set(STAGING_PATH ${CMAKE_BINARY_DIR}/src/souffle_disasm_${ARCH}.staging/)

  # Force reconfiguration if any of the datalog sources changed.
  get_directory_property(OLD_DEPS CMAKE_CONFIGURE_DEPENDS)
  set(NEW_DEPS "${OLD_DEPS};${DATALOG_BASE_SOURCES};${PARAM_DATALOG_SOURCES}")
  list(REMOVE_DUPLICATES NEW_DEPS)
  set_directory_properties(PROPERTIES CMAKE_CONFIGURE_DEPENDS "${NEW_DEPS}")

  # Recreate the staging directory
  file(REMOVE_RECURSE ${STAGING_PATH})
  file(MAKE_DIRECTORY ${STAGING_PATH})
  file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/src/${PARAM_PATH})

  # Generate CPP code
  execute_process(
    COMMAND
      ${SOUFFLE} main.dl -G ${STAGING_PATH} -jauto -MARCH_${PARAM_MARCH}
      ${SOUFFLE_PREPROCESSOR_ARG} ${SOUFFLE_PROFILING_ARG} -N ddisasm_${ARCH}
    WORKING_DIRECTORY "${SOUFFLE_DATALOG_DIR}")

  # Remove stale files from final generator output directory
  file(
    GLOB GENERATED_FILES
    RELATIVE "${CMAKE_BINARY_DIR}/src/${PARAM_PATH}/"
    "${CMAKE_BINARY_DIR}/src/${PARAM_PATH}/*")
  foreach(FILE ${GENERATED_FILES})
    if(NOT EXISTS "${STAGING_PATH}/${FILE}")
      file(REMOVE "${CMAKE_BINARY_DIR}/src/${PARAM_PATH}/${FILE}")
    endif()
  endforeach()

  # Copy modified files from staging to final generator output directory
  file(
    GLOB GENERATED_FILES
    RELATIVE "${STAGING_PATH}/"
    "${STAGING_PATH}/*")
  foreach(FILE ${GENERATED_FILES})
    execute_process(
      COMMAND ${CMAKE_COMMAND} -E copy_if_different "${STAGING_PATH}/${FILE}"
              "${CMAKE_BINARY_DIR}/src/${PARAM_PATH}")
  endforeach()
endfunction()

function(GENERATE_ARCH_STATIC_LIB)
  cmake_parse_arguments(PARAM "" "ARCH;MARCH;PATH" "DATALOG_SOURCES" ${ARGV})

  string(TOLOWER ${PARAM_ARCH} ARCH)
  set(GENERATED_CPP_PATH ${CMAKE_BINARY_DIR}/src/${PARAM_PATH})

  if(DDISASM_GENERATE_MANY)
    generate_arch_cpp_many(${ARGV})
  else()
    generate_arch_cpp_single(${ARGV})
  endif()

  if(DDISASM_GENERATE_MANY)
    file(GLOB GENERATED_CPP CONFIGURE_DEPENDS "${GENERATED_CPP_PATH}/*")
  else()
    set(GENERATED_CPP "${GENERATED_CPP_PATH}.cpp")
  endif()

  # Build generated code as a static library. Each arch needs its own library to
  # build with unique include paths. It also different compilation flags than
  # the rest of the source (because the generated souffle code won't build with
  # -Wall -Werror).
  add_library(ddisasm_datalog_${ARCH} STATIC ${GENERATED_CPP})

  target_compile_definitions(ddisasm_datalog_${ARCH} PRIVATE
                             __EMBEDDED_SOUFFLE__)
  target_compile_definitions(ddisasm_datalog_${ARCH} PRIVATE RAM_DOMAIN_SIZE=64)
  target_compile_options(ddisasm_datalog_${ARCH} PRIVATE ${OPENMP_FLAGS})

  target_include_directories(ddisasm_datalog_${ARCH}
                             PRIVATE ${GENERATED_CPP_PATH})
  if(SOUFFLE_INCLUDE_DIR)
    target_include_directories(ddisasm_datalog_${ARCH} SYSTEM
                               PRIVATE ${SOUFFLE_INCLUDE_DIR})
  endif()

  if(${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
    target_link_options(ddisasm_datalog_${ARCH} PRIVATE -NODEFAULTLIB:LIBCMTD)

    set_common_msvc_options(ddisasm_datalog_${ARCH})
    set_souffle_msvc_options(ddisasm_datalog_${ARCH})
  else()
    target_compile_options(ddisasm_datalog_${ARCH} PRIVATE -O3)
    target_compile_options(
      ddisasm_datalog_${ARCH} PRIVATE -Wno-parentheses-equality
                                      -Wno-unused-parameter)
  endif()

  # Disable var-tracking-assignments - uses too much memory when building
  # datalog code.
  if(${CMAKE_CXX_COMPILER_ID} STREQUAL GNU)
    target_compile_options(ddisasm_datalog_${ARCH}
                           PRIVATE -fno-var-tracking-assignments)
  endif()

  list(APPEND GENERATED_STATIC_LIB ddisasm_datalog_${ARCH})
  set(GENERATED_STATIC_LIB
      ${GENERATED_STATIC_LIB}
      PARENT_SCOPE)
endfunction()

=== examples/ex1/Makefile ===
CC="gcc"
CFLAGS=
EXEC=

all: ex.c
	$(CC) ex.c  $(CFLAGS) -o ex
	@ $(EXEC) ./ex > out.txt
clean:
	rm -f ex ex.unstripped out.txt *.s *.lib *.exp *.o *.err
check:
	@ $(EXEC) ./ex >/tmp/res.txt
	@ diff out.txt /tmp/res.txt && echo TEST OK

=== examples/ex_2modulesPIC/Makefile ===
CC="gcc"
CFLAGS=
EXEC=

all: ex.c
	$(CC) ex.c fun.c $(CFLAGS) -fPIC -o ex
	@ $(EXEC) ./ex > out.txt
clean:
	rm -f ex ex.unstripped out.txt *.s *.lib *.exp *.o *.err
check:
	@ $(EXEC) ./ex >/tmp/res.txt
	@ diff out.txt /tmp/res.txt && echo TEST OK

=== examples/ex_adder/Makefile ===
CC="gcc"
CFLAGS=
EXEC=

all: ex.c
	$(CC) ex.c  $(CFLAGS) -o ex
	@ $(EXEC) ./ex > out.txt
clean:
	rm -f ex out.txt
	rm -fr ex.unstripped *.s *.old*  dl_files *.gtirb
check:
	@ $(EXEC) ./ex >/tmp/res.txt
	@ diff out.txt /tmp/res.txt && echo TEST OK

=== examples/ex_call_once/Makefile ===
CXX="g++"
all: ex.cpp
	$(CXX) ex.cpp $(CXXFLAGS) -lpthread -o ex
	./ex > out.txt
clean:
	rm -f ex out.txt
	rm -fr ex.unstripped *.s *.old*  dl_files *.gtirb
check:
	./ex >/tmp/res.txt
	@ diff out.txt /tmp/res.txt && echo TEST OK

=== examples/ex_confusing_data/Makefile ===
CC="gcc"
CFLAGS=
EXEC=

all: ex.c
	$(CC) ex.c $(CFLAGS) -o ex
	@ $(EXEC) ./ex > out.txt
clean:
	rm -f ex ex.unstripped out.txt *.s *.lib *.exp *.o *.err
check:
	@ $(EXEC) ./ex >/tmp/res.txt
	@ diff out.txt /tmp/res.txt && echo TEST OK

=== examples/ex_copy_relo/Makefile ===
CC="gcc"
CFLAGS=
EXEC=

all: ex.c foo.c
	$(CC) -c foo.c  $(CFLAGS) -o foo.o -fPIC
	$(CC) -c ex.c  $(CFLAGS) -o ex.o
	$(CC) ex.o foo.o  $(CFLAGS) -o ex
	@ $(EXEC) ./ex > out.txt
clean:
	rm -f ex ex.unstripped out.txt *.s *.lib *.exp *.o *.err *.gtirb *.i
check:
	@ $(EXEC) ./ex >/tmp/res.txt
	@ diff out.txt /tmp/res.txt && echo TEST OK

=== .ci/PKGBUILD ===
# Contributor: Eric Schulte <eschulte@grammatech.com>
# Maintainer: Eric Schulte <eschulte@grammatech.com>
_srcname=ddisasm
pkgname=ddisasm-git
pkgver=v0.1.1.r628.gcd19fb5
pkgrel=1
pkgdesc="A fast and accurate disassembler"
arch=('x86_64')
url="https://github.com/grammatech/ddisasm"
license=('aGPLv3')
depends=('capstone' 'libehp' 'boost')
makedepends=('git' 'cmake' 'souffle' 'mcpp' 'lief' 'gtirb' 'gtirb-pprinter')
provides=('ddisasm')
source=('git://github.com/grammatech/ddisasm.git')
sha512sums=('SKIP')

pkgver() {
  cd "$_srcname"
  git describe --long --tags | sed 's/\([^-]*-g\)/r\1/;s/-/./g'
}

build() {
    cd "$_srcname/"
    cmake . -Bbuild -DCMAKE_INSTALL_PREFIX=/usr -DLIEF_ROOT=/usr -DLIEF_LIBRARY=/usr/lib/libLIEF.so -DCMAKE_BUILD_TYPE=$BUILD_TYPE
    make -C build
}

package() {
  cd "$_srcname/build"
  make DESTDIR="$pkgdir" install
}
